#include <iostream>
#include <cctype>
#include <cmath>
#include <complex>
#include <string>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <vector>

using namespace std;

#define DEBUG(x) cout << ">>> " #x << " : " << x << endl;


int S(vector<vector < pair<int,int> > > & mapa,int c,int r,int tileR,int tileC,int sizeR,int sizeC)
{
int res=0;
	vector<vector<int> > tiles;
	tiles.resize((sizeR/tileR)+2);
	for(int i=0;i<tiles.size();++i)
	{
		tiles[i].resize((sizeC/tileC)+2);
		for(int j=0;j<tiles[i].size();++j)
		{
			tiles[i][j]=0;
		}
	}	
	
	
	for(int i=0;i<mapa.size();i++)
	{
		for(int j=0;j<mapa[i].size();j++)
		{
			for(int k=mapa[i][j].first+c;k<mapa[i][j].second+c;k+=tileC)
			{
				tiles[(i+r)/tileR][k/tileC]=1;
			}
			tiles[(i+r)/tileR][(mapa[i][j].second+c)/tileC]=1;
		}	
	}
	
	for(int i=0;i<tiles.size();++i)
	{
		for(int j=0;j<tiles[i].size();++j)
		{
			res+=tiles[i][j];
		}
	}
return res;
}

int main() {
	
	int sizeR,sizeC,tileR,tileC;
	while(std::cin>>sizeR>>sizeC>>tileR>>tileC)
	{
		vector<vector < pair<int,int> > > mapa;
		std::string line;		
		for(int i=0;i<sizeR;++i)
		{
			std::cin >> line;
			char last='.';	
			vector < pair<int,int> > v;
			mapa.push_back(v);
			int j=0;
			for (std::string::iterator pnter(line.begin()); pnter!=line.end(); ++pnter)
			{
				if(*pnter!=last && *pnter=='X')
				{
					mapa[i].push_back(pair<int,int>(j,0));				
				}
				if(*pnter!=last && *pnter=='.')
				{
					mapa[i].back().second=j-1;
					//cout << mapa[i].back().first << " "<<  mapa[i].back().second<< endl;				
				}
				last=*pnter;
				j++;		
				
			}
			if(last=='X')
			{
				mapa[i].back().second=j-1;
				//cout << mapa[i].back().first << " "<<  mapa[i].back().second<< endl;
			}
			
		}

		int res=1000000000;
		for(int r=0;r<tileR;++r)
		{
			for(int c=0;c<tileC;++c)
			{
	
				res=min(res,S(mapa,c,r,tileR,tileC,sizeR,sizeC));

			}
		}	
		cout << res << endl;
		
	}
	return 0;
}
